unit uMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls,dOPC;

type
  TForm1 = class(TForm)
    TopPanel: TPanel;
    Label1: TLabel;
    ServerCombo: TComboBox;
    bConnect: TButton;
    Memo1: TMemo;
    CDataType: TComboBox;
    Label2: TLabel;
    Label3: TLabel;
    eFilter: TEdit;
    cbRead: TCheckBox;
    cbWrite: TCheckBox;
    OPCServer: TdOPCServer;
    procedure ServerComboDropDown(Sender: TObject);
    procedure bConnectClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure OPCServerError(Sender: TObject; Errorstring: String;
      var RaiseException: Boolean);

  private
    procedure ShowStatus;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormShow(Sender: TObject);
begin
   CDataType.ItemIndex := 0;
end;

procedure TForm1.ServerComboDropDown(Sender: TObject);
begin
  if trim(ServerCombo.Items.Text) = '' then  // if no OPC Servernames loaded
  begin
    Screen.Cursor := crHourGlass;
    GetOPCServers(ServerCombo.Items);        // get Servernames from registry
    Screen.Cursor := crDefault;
  end;
end;

procedure TForm1.ShowStatus;
begin
  Memo1.Lines.Add('StartTime   :'+ DateTimetoStr(OPCServer.StartTime));
  Memo1.Lines.Add('Currenttime :'+ DateTimetoStr(OPCServer.CurrentTime));
  // Memo1.Lines.Add('LastUpdate  :'+ DateTimetoStr(dvOPCServer1.LastUpdateTime));
  Memo1.Lines.Add('MajorVersion:'+ InttoStr(OPCServer.MajorVersion));
  Memo1.Lines.Add('MinorVersion:'+ InttoStr(OPCServer.MinorVersion));
  Memo1.Lines.Add('BuildNumber :'+ InttoStr(OPCServer.BuildNumber));
  Memo1.Lines.Add('BandWidth   :'+ InttoStr(OPCServer.BandWidth));
  Memo1.Lines.Add('GroupCount  :'+ InttoStr(OPCServer.GroupCount));
  Memo1.Lines.Add('ServerState :'+ InttoStr(OPCServer.ServerState));
  Memo1.Lines.Add('ServerState :'+ OPCServer.ServerStateStr);
  Memo1.Lines.Add('VendorInfo  :'+ OPCServer.VendorInfo);
end;

procedure GetAllItems(Browser: TdOPCBrowser; ItemList: TStrings);
var
  i       : integer;
  S       : TStringList;
begin
  S := TStringList.Create;
  Browser.ShowBranches;              // get all Branches in this level from OPC Server
  S.Assign(Browser.Items);           // save Items in new StringList
  Browser.ShowLeafs;
  for i := 0 to Browser.Count-1 do
    try
      ItemList.Add(Browser.GetItemId(Browser.Items[i]));
    except
    end;
  for i := 0 to S.Count-1 do         // for all Items in stringlist
  begin
    if Browser.MoveDown(S[i]) then   // one Level down
    begin
     GetAllItems(Browser,ItemList);  // recursive call
     Browser.MoveUp;                 // back to old Level
    end;
  end;
  S.Free;
end;


procedure TForm1.bConnectClick(Sender: TObject);
begin
  with OPCServer do
  begin
    Servername := ServerCombo.Text;
    Memo1.Clear;
    try
      Active := true;
      ShowStatus;
      Browser.Filter   := EFilter.Text;
      Browser.Datatype := OPCADataType(CDatatype.ItemIndex);
      Browser.AccessRights :=[];
      if cbWrite.Checked then
         Browser.AccessRights := Browser.AccessRights + [opcWritable];
      if cbRead.Checked then
         Browser.AccessRights := Browser.AccessRights + [opcReadable];
      GetAllItems(Browser,Memo1.Lines);
    finally
      Active := false;
    end;
  end;
end;


procedure TForm1.OPCServerError(Sender: TObject; Errorstring: String;
  var RaiseException: Boolean);
begin
  Memo1.Lines.Add(ErrorString);
end;

end.
